'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _neoBlockchainCore = require('neo-blockchain-core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let ConsensusPayload = function () {
  function ConsensusPayload({
    version,
    previousHash,
    blockIndex,
    validatorIndex,
    timestamp,
    data,
    script
  }) {
    (0, _classCallCheck3.default)(this, ConsensusPayload);
    this.serializeWire = (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this));

    this.version = version;
    this.previousHash = previousHash;
    this.blockIndex = blockIndex;
    this.validatorIndex = validatorIndex;
    this.timestamp = timestamp;
    this.data = data;
    this.script = script;
  }

  (0, _createClass3.default)(ConsensusPayload, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeUInt32LE(this.version);
      writer.writeUInt256(this.previousHash);
      writer.writeUInt32LE(this.blockIndex);
      writer.writeUInt16LE(this.validatorIndex);
      writer.writeUInt32LE(this.timestamp);
      writer.writeVarBytesLE(this.data);
      writer.writeUInt8(1);
      this.script.serializeWireBase(writer);
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { reader } = options;
      const version = reader.readUInt32LE();
      const previousHash = reader.readUInt256();
      const blockIndex = reader.readUInt32LE();
      const validatorIndex = reader.readUInt16LE();
      const timestamp = reader.readUInt32LE();
      const data = reader.readVarBytesLE();
      if (reader.readUInt8() !== 1) {
        throw new _neoBlockchainCore.InvalidFormatError();
      }
      const script = _neoBlockchainCore.Witness.deserializeWireBase(options);

      return new this({
        version,
        previousHash,
        blockIndex,
        validatorIndex,
        timestamp,
        data,
        script
      });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _neoBlockchainCore.BinaryReader(options.buffer)
      });
    }
  }]);
  return ConsensusPayload;
}();

exports.default = ConsensusPayload;