'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _neoBlockchainCore = require('neo-blockchain-core');

var _InventoryType = require('./InventoryType');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let InvPayload = function () {
  function InvPayload({
    type,
    hashes
  }) {
    (0, _classCallCheck3.default)(this, InvPayload);
    this.serializeWire = (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this));

    this.type = type;
    this.hashes = hashes;
  }

  (0, _createClass3.default)(InvPayload, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      writer.writeUInt8(this.type);
      writer.writeArray(this.hashes, value => {
        writer.writeUInt256(value);
      });
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase({ reader }) {
      const type = (0, _InventoryType.assertInventoryType)(reader.readUInt8());
      const hashes = reader.readArray(() => reader.readUInt256());
      return new this({ type, hashes });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _neoBlockchainCore.BinaryReader(options.buffer)
      });
    }
  }]);
  return InvPayload;
}();

exports.default = InvPayload;