'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _neoBlockchainCore = require('neo-blockchain-core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let MerkleBlockPayload = function (_BlockBase) {
  (0, _inherits3.default)(MerkleBlockPayload, _BlockBase);

  function MerkleBlockPayload({
    version,
    previousHash,
    merkleRoot,
    timestamp,
    index,
    consensusData,
    nextConsensus,
    script,
    transactionCount,
    hashes,
    flags
  }) {
    (0, _classCallCheck3.default)(this, MerkleBlockPayload);

    var _this = (0, _possibleConstructorReturn3.default)(this, (MerkleBlockPayload.__proto__ || (0, _getPrototypeOf2.default)(MerkleBlockPayload)).call(this, {
      version,
      previousHash,
      merkleRoot,
      timestamp,
      index,
      consensusData,
      nextConsensus,
      script
    }));

    _this.transactionCount = transactionCount;
    _this.hashes = hashes;
    _this.flags = flags;

    _this.__merkleBlockPayloadSize = _neoBlockchainCore.utils.lazy(() => (0, _get3.default)(MerkleBlockPayload.prototype.__proto__ || (0, _getPrototypeOf2.default)(MerkleBlockPayload.prototype), 'size', _this) + _neoBlockchainCore.IOHelper.sizeOfUInt32LE + _neoBlockchainCore.IOHelper.sizeOfArray(_this.hashes, () => _neoBlockchainCore.IOHelper.sizeOfUInt256) + _neoBlockchainCore.IOHelper.sizeOfVarBytesLE(_this.flags));
    return _this;
  }

  (0, _createClass3.default)(MerkleBlockPayload, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      (0, _get3.default)(MerkleBlockPayload.prototype.__proto__ || (0, _getPrototypeOf2.default)(MerkleBlockPayload.prototype), 'serializeWireBase', this).call(this, writer);
      writer.writeVarUIntLE(this.transactionCount);
      writer.writeArray(this.hashes, hash => {
        writer.writeUInt256(hash);
      });
      writer.writeVarBytesLE(this.flags);
    }
  }, {
    key: 'size',
    get: function () {
      return this.__merkleBlockPayloadSize();
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase(options) {
      const { reader } = options;
      const blockBase = (0, _get3.default)(MerkleBlockPayload.__proto__ || (0, _getPrototypeOf2.default)(MerkleBlockPayload), 'deserializeBlockBaseWireBase', this).call(this, options);
      const transactionCount = reader.readVarUIntLE(_neoBlockchainCore.utils.INT_MAX_VALUE).toNumber();
      const hashes = reader.readArray(() => reader.readUInt256());
      const flags = reader.readVarBytesLE();

      return new this({
        version: blockBase.version,
        previousHash: blockBase.previousHash,
        merkleRoot: blockBase.merkleRoot,
        timestamp: blockBase.timestamp,
        index: blockBase.index,
        consensusData: blockBase.consensusData,
        nextConsensus: blockBase.nextConsensus,
        script: blockBase.script,
        transactionCount,
        hashes,
        flags
      });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _neoBlockchainCore.BinaryReader(options.buffer)
      });
    }
  }]);
  return MerkleBlockPayload;
}(_neoBlockchainCore.BlockBase); /* @fl/*  */


exports.default = MerkleBlockPayload;