'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _neoBlockchainCore = require('neo-blockchain-core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let NetworkAddress = function () {
  function NetworkAddress({
    host,
    port,
    timestamp,
    services
  }) {
    (0, _classCallCheck3.default)(this, NetworkAddress);
    this.serializeWire = (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this));

    this.host = host;
    this.port = port;
    this.timestamp = timestamp;
    this.services = services;
  }

  (0, _createClass3.default)(NetworkAddress, [{
    key: 'serializeWireBase',
    value: function serializeWireBase(writer) {
      // TODO: Support non-ipv4 addresses
      const parts = this.host.split('.');
      if (parts.length !== 4) {
        throw new _neoBlockchainCore.InvalidFormatError();
      }
      const host = Buffer.from(parts.map(part => parseInt(part, 10)));

      writer.writeUInt8(this.timestamp);
      writer.writeUInt64LE(this.services);
      writer.writeBytes(host);
      // TODO: NEO node reverses endianness of machine, so this is
      //       technically not well-defined. Let's assume it's always
      //       trying to write little endian values.
      writer.writeUInt16LE(this.port);
    }
  }], [{
    key: 'deserializeWireBase',
    value: function deserializeWireBase({ reader }) {
      const timestamp = reader.readUInt8();
      const services = reader.readUInt64LE();
      const host0 = reader.readUInt8();
      const host1 = reader.readUInt8();
      const host2 = reader.readUInt8();
      const host3 = reader.readUInt8();
      const port = reader.readUInt16LE();
      return new this({
        timestamp,
        services,
        host: [host0, host1, host2, host3].join('.'),
        port
      });
    }
  }, {
    key: 'deserializeWire',
    value: function deserializeWire(options) {
      return this.deserializeWireBase({
        context: options.context,
        reader: new _neoBlockchainCore.BinaryReader(options.buffer)
      });
    }
  }]);
  return NetworkAddress;
}();

exports.default = NetworkAddress;